package ru.dbotthepony.kstarbound.world

import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kstarbound.json.builder.IStringSerializable

enum class Direction(val normal: Vector2d, val jsonName: String) : IStringSerializable {
	UP(Vector2d.POSITIVE_Y, "up"),
	RIGHT(Vector2d.POSITIVE_X, "right"),
	DOWN(Vector2d.NEGATIVE_Y, "down"),
	LEFT(Vector2d.NEGATIVE_X, "left"),
	NONE(Vector2d.ZERO, "any");

	override fun match(name: String): Boolean {
		return name.lowercase() == jsonName
	}

	override fun write(out: JsonWriter) {
		out.value(jsonName)
	}
}
